package br.mp.mprj.portal.portlet.caderno;

//import br.mp.mprj.portal.portlet.doerj.job.MigracaoPDFAntigosJobUtil;
//import br.mp.mprj.portal.portlet.doerj.util.DoerjUtil;

import br.mp.mprj.portal.portlet.caderno.rest.RestServices;
import br.mp.mprj.portal.portlet.caderno.service.GeraCaderno;
import br.mp.mprj.portal.portlet.caderno.util.CadernoUtil;
import br.mp.mprj.portal.portlet.caderno.util.Estilos;

import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.json.JSONFactoryUtil;
import com.liferay.portal.kernel.servlet.SessionErrors;
import com.liferay.portal.kernel.servlet.SessionMessages;
import com.liferay.portal.kernel.upload.UploadPortletRequest;
import com.liferay.portal.kernel.util.ParamUtil;
import com.liferay.portal.kernel.util.WebKeys;
import com.liferay.portal.theme.ThemeDisplay;
import com.liferay.portal.util.PortalUtil;
import com.liferay.portlet.PortletURLFactoryUtil;
import com.liferay.util.bridges.mvc.MVCPortlet;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Serializable;
import java.text.ParseException;
import java.util.HashMap;
import java.util.Map;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.PortletContext;
import javax.portlet.PortletException;
import javax.portlet.PortletMode;
import javax.portlet.PortletModeException;
import javax.portlet.PortletRequest;
import javax.portlet.PortletRequestDispatcher;
import javax.portlet.PortletURL;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
import javax.portlet.ResourceURL;
import javax.portlet.WindowState;
import javax.portlet.WindowStateException;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.Cookie;
import javax.xml.bind.JAXBException;
import javax.xml.namespace.QName;

import org.apache.log4j.Logger;
import org.docx4j.XmlUtils;
import org.docx4j.model.datastorage.migration.VariablePrepare;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.WordprocessingML.HeaderPart;
import org.docx4j.openpackaging.parts.WordprocessingML.MainDocumentPart;
import org.json.JSONArray;
import org.json.JSONObject;
import org.w3c.dom.DOMException;
import org.w3c.dom.Element;



public class CadernoPortlet extends MVCPortlet{
	
	final static Logger logger = Logger.getLogger(CadernoPortlet.class);

	public void serveResource(ResourceRequest resourceRequest,
			ResourceResponse resourceResponse) throws IOException,
			PortletException {
		ThemeDisplay themeDisplay = (ThemeDisplay) resourceRequest.getAttribute(WebKeys.THEME_DISPLAY);
		UploadPortletRequest uploadRequest=PortalUtil.getUploadPortletRequest(resourceRequest);
		String valor = ParamUtil.getString(resourceRequest, "parameter");
		String cmd = ParamUtil.getString(resourceRequest, "caderno");
		String dataDivulgacao = ParamUtil.getString(uploadRequest, "dataP");
		String situacao = ParamUtil.getString(uploadRequest, "situacao");

		//System.out.println(valor);
			
			com.liferay.portal.kernel.json.JSONObject jsonResponse = JSONFactoryUtil.createJSONObject();
			
			if (cmd.equals("geraCaderno")){
				
				try {
					//geraCaderno(resourceRequest,resourceResponse,dataDivulgacao,situacao);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}else{
				//System.out.println(valor);
				try {
					jsonResponse.put("result", CadernoUtil.getDatasCadastradas());
					
				} catch (SystemException e) {
					// TODO Auto-generated catch block
					logger.error("Erro requisicao AJAX",e);
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					logger.error("Erro validar horários AJAX",e);
				}
				// Writing the result in resourceResponse writer.
				PrintWriter writer = resourceResponse.getWriter();
				writer.println(jsonResponse);
			// Creating a JSON object which will contain the sum.
			}
			
			PortletURL renderUrl = resourceResponse.createRenderURL();  
			//renderUrl.setParameter("erro", "");   
		//	resourceResponse.addProperty("Location", renderUrl.toString());
			//resourceResponse.encodeURL(renderUrl.toString());
			//resourceResponse.createActionURL().addProperty("Location", renderUrl.toString());
			//resourceResponse.createRenderURL();
			resourceResponse.addProperty("Location", resourceResponse.createRenderURL().toString());
			return;
			
		
	}
	
	public void geraCaderno(ActionRequest actionRequest, ActionResponse actionResponse)throws Exception {

		UploadPortletRequest uploadRequest=PortalUtil.getUploadPortletRequest(actionRequest);
		ThemeDisplay themeDisplay = (ThemeDisplay) uploadRequest.getAttribute(WebKeys.THEME_DISPLAY);
		String dataDivulgacao = ParamUtil.getString(uploadRequest, "dataP");
		String idStatus = ParamUtil.getString(uploadRequest, "situacao");
		
		
		JSONArray listaConteudos = new JSONArray();
		RestServices rest = new RestServices();
		String dataDivulgacaoRest = dataDivulgacao.replace("/", "");
		listaConteudos = rest.getRest(dataDivulgacaoRest,idStatus);
		SessionMessages.add(actionRequest.getPortletSession(), PortalUtil.getPortletId(actionRequest) + SessionMessages.KEY_SUFFIX_HIDE_DEFAULT_SUCCESS_MESSAGE);
		
		if(!mensagensDeErro(listaConteudos, dataDivulgacao, actionRequest)){
		GeraCaderno caderno = new GeraCaderno();
		
		caderno.processaCaderno(actionRequest, actionResponse,listaConteudos,dataDivulgacao);
		}else{
		
			/*com.liferay.portal.kernel.json.JSONObject jsonResponse = JSONFactoryUtil.createJSONObject();
			jsonResponse.put("erroDataNula", true);
			PrintWriter writer = resourceResponse.getWriter();
			writer.println(jsonResponse);*/
			
           /* PortletRequestDispatcher dispatcher;
            dispatcher = getPortletContext().getRequestDispatcher("/jsp/admin/view-admin.jsp");
            dispatcher.include(resourceRequest, resourceResponse);*/
			
		
		//	SessionMessages.add(actionRequest.getPortletSession(), "erro");
			String portletName = (String) actionRequest.getAttribute(WebKeys.PORTLET_ID);
			
			
			/*PortletURL redirectURL = PortletURLFactoryUtil.create(PortalUtil.getHttpServletRequest(resourceRequest), portletName, themeDisplay.getLayout().getPlid(),
					PortletRequest.RENDER_PHASE);
			redirectURL.setParameter("jspPage", "/jsp/admin/view-admin.jsp");
			((ActionResponse) resourceResponse).sendRedirect(redirectURL.toString());*/
			
		}
		
		/*String portletName = (String) resourceRequest.getAttribute(WebKeys.PORTLET_ID);
		PortletURL redirectURL = PortletURLFactoryUtil.create(PortalUtil.getHttpServletRequest(resourceRequest), portletName, themeDisplay.getLayout().getPlid(),
				PortletRequest.RENDER_PHASE);
		redirectURL.setParameter("jspPage", "/jsp/admin/view-admin.jsp");
		//resourceResponse.sendRedirect(redirectURL.toString());*/
		
		//HttpServletResponse httpResponse = PortalUtil.getHttpServletResponse(resourceResponse);
		//httpResponse.sendRedirect(redirect);
		
		
		
	}
	
	
	
	protected Boolean mensagensDeErro(JSONArray listaConteudos, String dataDivulgacao, ActionRequest actionRequest) throws ParseException{
		Boolean contemErro = Boolean.FALSE;
		
		if(listaConteudos.length()==0 && !dataDivulgacao.equals("")) {
			contemErro = Boolean.TRUE;
			actionRequest.setAttribute("erroListagemNula", true);
			
			SessionErrors.add(actionRequest.getPortletSession(), "erroListagemNula");
			SessionMessages.add(actionRequest.getPortletSession(), PortalUtil.getPortletId(actionRequest) + SessionMessages.KEY_SUFFIX_HIDE_DEFAULT_ERROR_MESSAGE);
		} else 	if(dataDivulgacao.equals("")) {
			contemErro = Boolean.TRUE;
			actionRequest.setAttribute("erroDataNula", true);
			SessionErrors.add(actionRequest.getPortletSession(), "erroDataNula");
			SessionMessages.add(actionRequest.getPortletSession(), PortalUtil.getPortletId(actionRequest) + SessionMessages.KEY_SUFFIX_HIDE_DEFAULT_ERROR_MESSAGE);
		} 
		return contemErro;
	}
	
}
