package br.mp.mprj.portal.portlet.caderno.service;

import com.liferay.portal.util.PortalUtil;

import br.mp.mprj.portal.portlet.caderno.util.CadernoUtil;
import br.mp.mprj.portal.portlet.caderno.util.Estilos;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.text.ParseException;
import java.util.HashMap;
import java.util.Locale;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.CacheControl;
import javax.portlet.ClientDataRequest;
import javax.portlet.PortletContext;
import javax.portlet.PortletRequest;
import javax.portlet.PortletResponse;
import javax.portlet.PortletURL;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
import javax.portlet.ResourceURL;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.bind.JAXBException;

import org.apache.commons.compress.utils.IOUtils;
import org.apache.poi.ss.formula.functions.Replace;
import org.docx4j.XmlUtils;
import org.docx4j.openpackaging.Base;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.WordprocessingML.HeaderPart;
import org.docx4j.openpackaging.parts.WordprocessingML.MainDocumentPart;
import org.json.JSONArray;
import org.json.JSONObject;
import org.w3c.dom.DOMException;
import org.w3c.dom.Element;

public class GeraCaderno {
	
	
	public static void processaCaderno(ActionRequest actionRequest,ActionResponse actionResponse,JSONArray listaConteudos,String dataDivulgacao) throws Docx4JException, JAXBException, IOException, ParseException{
		
		
		PortletContext context = actionRequest.getPortletSession().getPortletContext();
		String pathTemplate = context.getRealPath("/template");
		String conteudo="";
		String orgao="";
		String titulo="";
		
		  CadernoUtil util = new CadernoUtil();
		 MainDocumentPart currentDocumentPart = null;
		 WordprocessingMLPackage templatePackage = WordprocessingMLPackage.load(new File(pathTemplate + "/" + "TemplateCaderno.docx"));
		System.out.println(XmlUtils.marshaltoString(templatePackage.getMainDocumentPart().getJaxbElement(), true, true));
		 WordprocessingMLPackage acumuladoPackage = WordprocessingMLPackage.createPackage();

//Preenche os dados do cabeçalho
		 
		 MainDocumentPart headerDocumentPart = templatePackage.getMainDocumentPart();
		 
		 
		 MainDocumentPart mainPart = templatePackage.getMainDocumentPart();
		 HeaderPart headerPart = templatePackage.getHeaderFooterPolicy().getDefaultHeader();
		 HeaderPart firstPageHeaderPart = templatePackage.getHeaderFooterPolicy().getFirstHeader();
		 	
		   // VariablePrepare.prepare(templatePackage);
		    
		    JSONObject cabecalho = new JSONObject(listaConteudos.getJSONObject(0).toString());
		    
		    //String edicao = cabecalho.get("EDICAO").toString();
		    String edicao = "EDIÇÃO TESTE";
		   //String disponibilizacao = cabecalho.get("DISPONIBILIZACAO").toString();
		    String disponibilizacao = util.gerarDataCabecalho(dataDivulgacao);
		    //String publicacao = cabecalho.get("PUBLICACAO").toString();
		    String publicacao = "PUBLICAÇÃO TESTE";
	
		    String textoMain="José Eduardo Ciotola Gussem";
		    
		    
//Cria o hash map com as variáveis para substuição dos dados dos cabeçalhos e expediente		    
		   HashMap<String, String> variables = new HashMap<String, String>();
		    variables.put("edicao", edicao);
		    variables.put("disponibilizacao", disponibilizacao);
		    variables.put("publicacao", publicacao);
		    variables.put("PGJ", textoMain);
		    
		    textoMain="Luciana Sapha Silveira";
		    variables.put("CGMP", textoMain);
		    
		    textoMain="Eduardo da Silva Lima Neto";
		    variables.put("SGJA", textoMain);
		    
		    textoMain="Leila Machado Costa";
		    variables.put("SGJPI", textoMain);
		    
		    textoMain="Sérgio Roberto Ulhôa Pimentel";
		    variables.put("SGJACI", textoMain);
		    
		    textoMain="Fernando Chaves da Costa";
		    variables.put("SGJACDH", textoMain);
		    
		    textoMain="Marfan Martins Vieira";
		    variables.put("SGJRIDP", textoMain);
		    
		    textoMain="Virgilio Panagiotis Stavridis";
		    variables.put("CG", textoMain);
		    
		    textoMain="Emerson Garcia";
		    variables.put("CJ", textoMain);

		    textoMain="Mária Luiza Bezerra Cortes Barroso Miranda";
		    variables.put("AE", textoMain);

		    textoMain="Vera de Souza Leite";
		    variables.put("CMPROCJ", textoMain);
		    
		    textoMain="Patricia Mothé Glioche Béze";
		    variables.put("CMPROMJ", textoMain);
		    
		    textoMain="Elisa Fraga de Rego Monteiro";
		    variables.put("CSI", textoMain);
		    
		    textoMain="Leandro Silva Navega";
		    variables.put("CEAF", textoMain);

		    textoMain="José Roberto Paredes";
		    variables.put("OUVI", textoMain);
		    
		    textoMain="Dimitrius Viveiros Gonçalves";
		    variables.put("SGMP", textoMain);

		    textoMain="Fernanda Moreira Jorgensen (Assessora-Chefe)";
		    variables.put("AAOMC", textoMain);
		    
		    textoMain="Inês da Matta Andreiuolo (Assessora-Chefe)";
		    variables.put("ARCC", textoMain);

		    textoMain="Cláucio Cardoso da Conceição (Coordenador)";
		    variables.put("GAOMC", textoMain);
		    
		    textoMain="Orlando Carlos Neves Belém (Assessor-Chefe)";
		    variables.put("ARCCRI", textoMain);

		    textoMain="Antonio Carlos Silva Biscaia (Assessor-Chefe)";
		    variables.put("AC", textoMain);

		    textoMain="Eliane de Lima Pereira";
		    variables.put("ADHM", textoMain);

		    textoMain="Ertulei Laureano Matos";
		    variables.put("ARIDP", textoMain);
		    
		    textoMain="Humberto Dalla Bernadina de Pinho";
		    variables.put("AI", textoMain);
		    
		    textoMain="Victoria Siqueiros Soares Le Cocq D`Oliveira";
		    variables.put("AAP", textoMain);

		    
		    firstPageHeaderPart.variableReplace(variables);
		    headerPart.variableReplace(variables);
		    mainPart.variableReplace(variables);
		 
		 
	       Estilos estilo = new Estilos();
	       estilo.alterStyleSheet(acumuladoPackage);
	       WordprocessingMLPackage firstPagePackage = WordprocessingMLPackage.createPackage();
	     
	       boolean firstPage=true;
	  
	 //faz a leitura da listagem de todos os conteúdos recebidos pelo serviço Rest      
		for(int i=0;i<listaConteudos.length();i++){
			
			WordprocessingMLPackage wordCurrentPackage = WordprocessingMLPackage.createPackage();
		           JSONObject obj = new JSONObject(listaConteudos.get(i).toString());
		           
		           
		           orgao = obj.get("ORGAO").toString();
		            orgao = util.tratarString(orgao,"titulo");
					
		           
		            titulo = obj.get("NOME").toString();
					titulo = util.tratarString(titulo,"titulo");
					
					
					conteudo = obj.get("CONTEUDO").toString();
			
					conteudo=util.tratarString(conteudo,"conteudo");
			
					wordCurrentPackage = util.ConverterHTML(conteudo,orgao,titulo);

					currentDocumentPart = wordCurrentPackage.getMainDocumentPart();
					acumuladoPackage.getMainDocumentPart().getContent().addAll(currentDocumentPart.getContent());
					wordCurrentPackage = null;
					currentDocumentPart =null;
					//firstDocumentPart=null;
			       
		}
		
	
		
		
		MainDocumentPart acumuladoDocumentPart = acumuladoPackage.getMainDocumentPart();
	
		estilo.alterStyleSheet(templatePackage);

		templatePackage.getMainDocumentPart().getContent().addAll(acumuladoDocumentPart.getContent());
		
		util.ORGAO="";
		util.TITULO="";
		//File exportFile = new File("C:/Users/diogo.souza/Documents/Caderno DO/testeDoc4JNovo.docx");
		String dataNomeArquivo = dataDivulgacao.replace("/", "-");
		String nomeArquivo="caderno_doerj_" + dataNomeArquivo;
		File exportFile = new File(pathTemplate + "/" + nomeArquivo + ".docx");
		templatePackage.save(exportFile);
		
		
		
		/*response.setContentType("application/force-download");
		((PortletResponse) response).addProperty("Content-Disposition", "attachment; filename="+nomeArquivo + ".docx");
		File outputFile = new File(System.getProperty("java.io.tmpdir"), nomeArquivo);
		
		FileInputStream in = new FileInputStream(exportFile);
		OutputStream out = resourceResponse.getPortletOutputStream();
		
		//wb.write(out);
		byte[] buffer = new byte[4096];
		int length;
			while ((length = in.read(buffer)) > 0){
			    out.write(buffer, 0, length);
			}
		in.close();
		out.flush();
		out.close();*/
		
		PortletRequest pRequest = PortalUtil.getLiferayPortletRequest(actionRequest);
		PortletResponse pResponse = PortalUtil.getLiferayPortletResponse(actionResponse);

		HttpServletRequest req = PortalUtil.getHttpServletRequest(pRequest);
        HttpServletResponse res = PortalUtil.getHttpServletResponse(pResponse);
        res.setHeader("Content-Disposition", "attachment; filename="+nomeArquivo + ".docx");//
        res.setHeader("Content-Transfer-Encoding", "binary");
        res.setContentType("application/force-download");
        
        FileInputStream in = new FileInputStream(exportFile);
        OutputStream out = res.getOutputStream();
       
                  byte[] buffer = new byte[4096];
              
                  int numBytesRead;
                  while ((numBytesRead = in.read(buffer)) > 0) {
                      out.write(buffer, 0, numBytesRead);
                  }
              
        res.flushBuffer();
		
	}

}
